import "core-js/modules/es6.regexp.match";
var regx = {
  name: /[^\u65e0]{1}[a-zA-Z\u4e00-\u9fa5]{0,30}/g,
  phone: /^(?=\d{11}$)^1(?:3\d|4[57]|5[^4\D]|66|7[^249\D]|8\d|9[89])\d{8}$/,
  email: /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
};
export function verify(value) {
  var reg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var allData = arguments.length > 2 ? arguments[2] : undefined;
  var message = '';
  var nullReg = reg.filter(function (r) {
    return r.reg === 'empty';
  })[0];

  if (nullReg) {
    message = !!(value + '') ? '' : nullReg['message'];
    if (message) return message;
  }

  reg.forEach(function (r) {
    var re = r['reg'];

    if (re !== 'empty' && value !== '') {
      if (r.verifyFn) {
        message = r.verifyFn(value, allData) ? '' : r['message'];
      } else {
        message = !!value.match(regx[re]) ? '' : r['message'];
      }
    }
  });
  return message;
}