import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import React, { Component } from 'react';
import FormComponentMap from './formComponentMap';
import * as formVerify from './formVerify';
import deepClone from './util';

require('./form.css');

import omit from 'lodash.omit';

var _default =
/*#__PURE__*/
function (_Component) {
  _inherits(_default, _Component);

  function _default(props) {
    var _this;

    _classCallCheck(this, _default);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(_default).call(this, props));

    _this.triggerFormVerify = function () {
      _this.state.dataSource.map(function (item, index) {
        if (item.rule) {
          _this.changeHandler(index, item.value);
        }
      });
    };

    _this.handleExEdit = _this.handleExEdit.bind(_assertThisInitialized(_this));
    _this.handleExBack = _this.handleExBack.bind(_assertThisInitialized(_this));
    _this.handleSubmit = _this.handleSubmit.bind(_assertThisInitialized(_this));
    _this.state = {
      dataSource: deepClone(props.dataSource),
      isEdit: false
    };
    _this.copyDataSource = deepClone(props.dataSource);
    return _this;
  } // componentWillReceiveProps(nextProps) {
  //     if(this.state.dataSource !== nextProps.dataSource) {
  //         this.setState({dataSource: deepClone(nextProps.dataSource) });
  //     }
  // }

  /**
  * 执行编辑按钮
  */


  _createClass(_default, [{
    key: "handleExEdit",
    value: function handleExEdit() {
      this.setState({
        isEdit: true
      });
    }
    /**
    * 执行返回按钮
    */

  }, {
    key: "handleExBack",
    value: function handleExBack() {
      this.copyDataSource = deepClone(this.props.dataSource);
      this.setState({
        dataSource: deepClone(this.props.dataSource),
        isEdit: false
      });
    }
    /**
    * 执行保存按钮
    */

  }, {
    key: "handleSubmit",
    value: function handleSubmit(name) {
      for (var i = 0; i < this.copyDataSource.length; i++) {
        var item = this.copyDataSource[i];

        if (item.rule) {
          var message = formVerify.verify(item.value, item.rule, this.copyDataSource);
          this.copyDataSource[i]['errorMessage'] = message ? message : '';

          if (message) {
            this.setState({
              dataSource: this.copyDataSource
            });
            return;
          }
        }
      }

      this.props.submitForm && this.props.submitForm(this.copyDataSource);
      this.setState({
        isEdit: false
      });
    }
  }, {
    key: "changeHandler",
    value: function changeHandler(index, val, e) {
      var text,
          value = '';

      if (typeof val === 'string') {
        text = value = val;
        var message = formVerify.verify(value, this.copyDataSource[index]['rule'], this.copyDataSource);
        this.copyDataSource[index]['errorMessage'] = message ? message : '';
        this.props.formErrorNotify && this.props.formErrorNotify({
          field: this.copyDataSource[index]['filed'],
          message: message
        });
      } else {
        text = val['text'];
        value = val['value'];

        if (this.copyDataSource[index]['biz_data']) {
          this.copyDataSource[index]['biz_data'].forEach(function (item) {
            item.selected = item.value === val['value'];
          });
        }
      }

      this.copyDataSource[index].text = text;
      this.copyDataSource[index].value = value; // 手机号特殊处理，手机类型

      if (index === 1 && typeof val === 'string') {
        this.copyDataSource[index].mobileType = e || this.copyDataSource[index].mobileType;
      }

      this.setState({
        dataSource: this.copyDataSource
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement("div", {
        className: "form-container"
      }, React.createElement("table", {
        className: "content"
      }, React.createElement("tbody", null, this.state.dataSource.map(function (ele, index) {
        if (ele.visible === false) {
          return;
        }

        var FormComponent = FormComponentMap.getComponentMap(ele['cmp_type'] || 'input');
        return React.createElement("tr", {
          key: index
        }, React.createElement("td", {
          className: "filed"
        }, ele.fieldName), React.createElement("td", {
          id: index,
          className: "value"
        }, _this2.state.isEdit ? React.createElement(FormComponent, _extends({
          dataSource: ele['biz_data'],
          fieldName: 'text',
          onChange: _this2.changeHandler.bind(_this2, index),
          isShowArrow: false,
          disabled: ele.disabled,
          errorMessage: ele.errorMessage,
          text: ele.text,
          value: ele.value
        }, omit(ele, ['text', 'value', 'errorMessage', 'disabled', 'fieldName', 'biz_data']))) : React.createElement("input", {
          className: "txt",
          disabled: "disabled",
          title: ele.text,
          value: ele.text
        }), React.createElement("div", {
          className: "message"
        }, ele.errorMessage), _this2.state.isEdit && ele.filed == 'mobile' && ele.mobileType == 'oth' && React.createElement("div", {
          className: "mobile-tip"
        }, "\u8BF7\u5728\u624B\u673A\u53F7\u524D\u8F93\u5165\u201D00\u201C\u548C\u56FD\u5BB6\u7801")));
      }))));
    }
  }]);

  return _default;
}(Component);

export { _default as default };