import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import React from 'react'; // import './index.css';

import Input from '../input';
import Dropdown from 'recruit-dropdown';
var mobileTypeMap = {
  'ch': 0,
  'oth': 1
};
var mobileTypeMapValue = {
  0: 'ch',
  1: 'oth'
};

var InputPhone =
/*#__PURE__*/
function (_React$Component) {
  _inherits(InputPhone, _React$Component);

  function InputPhone(props) {
    var _this;

    _classCallCheck(this, InputPhone);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(InputPhone).call(this, props));

    _this.handleDropDownChange = function (obj) {
      if (obj.value === _this.dropDownDefaultValue) {
        return;
      }

      _this.dropDownDefaultValue = obj.value;

      _this.props.onChange(_this.props.text, mobileTypeMapValue[_this.dropDownDefaultValue]);
    };

    _this.getDropDownProps = function () {
      var obj = {
        fieldName: 'text',
        disabled: false,
        isShowArrow: false,
        errorMessage: '',
        onChange: _this.handleDropDownChange,
        text: '',
        value: '',
        dataSource: [{
          text: '大陆手机号',
          value: 0,
          selected: _this.dropDownDefaultValue === 0
        }, {
          text: '非大陆手机号',
          value: 1,
          selected: _this.dropDownDefaultValue === 1
        }]
      };
      return obj;
    };

    _this.handleInputChange = function (val) {
      _this.props.onChange(val, mobileTypeMapValue[_this.dropDownDefaultValue]);
    };

    _this.getInputProps = function () {
      var _this$props = _this.props,
          text = _this$props.text,
          value = _this$props.value,
          disabled = _this$props.disabled,
          errorMessage = _this$props.errorMessage;
      var obj = {
        text: text,
        value: value,
        fieldName: 'text',
        isShowArrow: false,
        disabled: disabled,
        errorMessage: errorMessage,
        onChange: _this.handleInputChange,
        placeholder: '请输入手机号'
      };
      return obj;
    };

    _this.dropDownDefaultValue = mobileTypeMap[_this.props.mobileType || 'ch'];
    return _this;
  }

  _createClass(InputPhone, [{
    key: "render",
    value: function render() {
      return React.createElement("div", {
        className: "input-phone"
      }, React.createElement(Dropdown, this.getDropDownProps()), React.createElement(Input, this.getInputProps()));
    }
  }]);

  return InputPhone;
}(React.Component);

export { InputPhone as default };