import React, { Component } from 'react';
import Input from '../input';
import Calendar from 'rc-calendar';
import DatePicker from 'rc-calendar/lib/Picker';
import zhcn from 'rc-calendar/lib/locale/zh_CN';
import moment from 'moment';
import 'moment/locale/zh-cn';
require('rc-calendar/assets/index.css');
require('./index.scss');

export default class extends Component {
    static defaultProps = {
        format: 'YYYY-MM-DD',
        showDateInput: false,
        showToday: false
    }

    constructor(props) {
        super(props);
        this.onChange = this.onChange.bind(this);
        this.onSelect = this.onSelect.bind(this);
        this.state = {
            showClalendar: false,
            text: props.text,
            value: props.value
        }
    }

    onChange(value) {
        this.setState({text: value.format('LL'), value: value.format('L')});
    }

    onSelect(value) {
      this.setState({text: value.format('LL'), value: value.format('L'),showClalendar: false}, () => {
          this.props.onChange && this.props.onChange({text: this.state.text, value: value.format('L').replace(/\-/g, '/')});
      });
    }

    render () {
        return (
            <div className='date-container'>
                {this.state.showClalendar ? <div className='mask' onClick={() => this.setState({showClalendar: false})}></div> : null}
                <Input value={this.state.text}
                       onFocus={() => this.setState({showClalendar: true})}
                       readOnly={true}
                       />
                {this.state.showClalendar ? <Calendar locale={zhcn}
                                                      formatter={this.props.format}
                                                      showDateInput={this.props.showDateInput}
                                                      showToday={this.props.showToday}
                                                      style={{position: 'absolute', zIndex: 100}}
                                                      onChange={this.onChange}
                                                      onSelect={this.onSelect}
                                                      value={this.state.value ? moment(this.state.value) : moment()}
                                                      /> : null}
            </div>
        );
    }
}