import React,{ Component } from 'react';
import FormComponentMap from './formComponentMap';
import * as formVerify from './formVerify';
import deepClone from './util'
require('./form.scss');
import omit from 'lodash.omit';

export default class extends Component {
    constructor(props) {
        super(props);
        this.handleExEdit = this.handleExEdit.bind(this);
        this.handleExBack = this.handleExBack.bind(this);
				this.handleSubmit = this.handleSubmit.bind(this);
        this.state = {
            dataSource: deepClone(props.dataSource),
						isEdit: false
				};
        this.copyDataSource = deepClone(props.dataSource);
    }

    // componentWillReceiveProps(nextProps) {
    //     if(this.state.dataSource !== nextProps.dataSource) {
    //         this.setState({dataSource: deepClone(nextProps.dataSource) });
    //     }
    // }
    /**
    * 执行编辑按钮
    */
    handleExEdit() {
        this.setState({isEdit: true})
    }

    /**
    * 执行返回按钮
    */
    handleExBack() {
        this.copyDataSource = deepClone(this.props.dataSource);
        this.setState({dataSource: deepClone(this.props.dataSource), isEdit: false});
    }
    /**
    * 执行保存按钮
    */
    handleSubmit(name) {
        for (let i = 0; i < this.copyDataSource.length; i++) {
            let item = this.copyDataSource[i];
            if (item.rule) {
                const message = formVerify.verify(item.value, item.rule, this.copyDataSource);
                this.copyDataSource[i]['errorMessage'] = message ? message : '';
                if (message) {
                    this.setState({
                        dataSource: this.copyDataSource
                    })
                    return;
                }
            }
        }
        this.props.submitForm && this.props.submitForm(this.copyDataSource);
        this.setState({isEdit: false})
    }

    changeHandler(index, val, e) {
				let text, value = '';
        if(typeof val  === 'string') {
						text = value = val
						const message = formVerify.verify(value, this.copyDataSource[index]['rule'], this.copyDataSource);
            this.copyDataSource[index]['errorMessage'] = message ? message : '';
            this.props.formErrorNotify && this.props.formErrorNotify({field: this.copyDataSource[index]['filed'], message: message});
        }else {
            text = val['text'];
            value = val['value'];
            if(this.copyDataSource[index]['biz_data']) {
                this.copyDataSource[index]['biz_data'].forEach(item => {
                    item.selected = (item.value === val['value']);
                });
            }
				}
        this.copyDataSource[index].text = text;
        this.copyDataSource[index].value = value;
        // 手机号特殊处理，手机类型
        if (index === 1 && typeof val === 'string') {
            this.copyDataSource[index].mobileType = e || this.copyDataSource[index].mobileType;
        }
        this.setState({
					dataSource: this.copyDataSource
				});
		}
		
    triggerFormVerify = () => {
        this.state.dataSource.map((item, index) => {
            if(item.rule) {
                this.changeHandler(index, item.value)
            }
        })
    }
    render() {

    
        return (
            <div className='form-container'>
                <table className='content'>
                  <tbody>
                    {
                        this.state.dataSource.map((ele,index)=>{
                            if(ele.visible === false) {
                                return ;
                            }
                            const FormComponent = FormComponentMap.getComponentMap(ele['cmp_type'] || 'input');
                            return (<tr key={index}>
                                        <td className='filed'>{ele.fieldName}</td>
                                        {<td id={index} className='value'>
                                            {this.state.isEdit ?
                                            <FormComponent dataSource={ele['biz_data']}
                                                           fieldName={'text'}
                                                           onChange={this.changeHandler.bind(this, index)}
                                                           isShowArrow={false}
                                                           disabled={ele.disabled}
                                                           errorMessage={ele.errorMessage}
                                                           text={ele.text}
                                                           value={ele.value}
                                                           {...omit(ele, ['text', 'value', 'errorMessage', 'disabled', 'fieldName', 'biz_data'])}
                                                           /> : <input className='txt' disabled='disabled' title={ele.text} value={ele.text}/>
                                            }
                                            <div className='message'>{ele.errorMessage}</div>
                                            {(this.state.isEdit && ele.filed == 'mobile' && ele.mobileType == 'oth')
                                            && <div className='mobile-tip'>请在手机号前输入”00“和国家码</div>
                                            }
                                        </td>}
                                    </tr>)

                        })
                      }
                    </tbody>
                </table>
            </div>
        )
    }
}


