import React from 'react';
// import './index.scss';
import Input from '../input';
import Dropdown from 'recruit-dropdown';

const mobileTypeMap = {
  'ch': 0,
  'oth': 1
};

const mobileTypeMapValue = {
  0: 'ch',
  1: 'oth'
};

export default class InputPhone extends React.Component {

  constructor(props) {
    super(props);
    this.dropDownDefaultValue = mobileTypeMap[this.props.mobileType || 'ch'];
  }

  handleDropDownChange = (obj) => {
    if (obj.value === this.dropDownDefaultValue) {
      return;
    }
    this.dropDownDefaultValue = obj.value;
    this.props.onChange(this.props.text, mobileTypeMapValue[this.dropDownDefaultValue]);
  }

  getDropDownProps = () => {
    let obj = {
      fieldName: 'text',
      disabled: false,
      isShowArrow: false,
      errorMessage: '',
      onChange: this.handleDropDownChange,
      text: '',
      value: '',
      dataSource: [
        {
          text: '大陆手机号',
          value: 0,
          selected: this.dropDownDefaultValue === 0
        },
        {
          text: '非大陆手机号',
          value: 1,
          selected: this.dropDownDefaultValue === 1
        }
      ]
    };
    return obj;
  }

  handleInputChange = (val) => {
    this.props.onChange(val, mobileTypeMapValue[this.dropDownDefaultValue]);
  }

  getInputProps = () => {
    const { text, value, disabled, errorMessage } = this.props;
    let obj = {
      text: text,
      value: value,
      fieldName: 'text',
      isShowArrow: false,
      disabled: disabled,
      errorMessage: errorMessage,
      onChange: this.handleInputChange,
      placeholder: '请输入手机号'
    };
    return obj;
  }

  render() {
    return (
      <div className='input-phone'>
        <Dropdown {...this.getDropDownProps()} />
        <Input {...this.getInputProps()} />
      </div>
    )
  }
}