import React, { Component } from 'react';
require('./index.scss');

export default class extends Component {
    static defaultProps = {
        readOnly: false,
        disabled: false,
        errorMessage: ''
    }

    constructor(props) {
        super(props);
        this.onChangeHandler = this.onChangeHandler.bind(this);
        this.onBlurHandler = this.onBlurHandler.bind(this);

        this.state = {
            value: props.value
        }
    }

    componentWillReceiveProps(nextProps) {
        if(this.state.value !== nextProps.value) {
            this.setState({value: nextProps.value});
        }
    }

    onChangeHandler(e) {
        this.setState({value: e.target.value});
    }

    onBlurHandler(e) {
        this.props.onChange && this.props.onChange(e.target.value);
    }

    render () {
        return <input className={`inputcomponent${this.props.readOnly ? ' readonly' : ''}${this.props.disabled ? ' disabled' : ''}${this.props.errorMessage ? ' error' : ''}`}
                      disabled={this.props.disabled ? 'disabled' : false}
                      readOnly={this.props.readOnly ? 'readOnly' : false}
                      value={this.state.value}
                      onFocus={this.props.onFocus}
                      onChange={this.onChangeHandler}
                      onBlur={this.onBlurHandler}
                      placeholder={this.props.placeholder || ''}
                      />
    }
}